#!/usr/bin/env node

const { execSync } = require('child_process');
const path = require('path');
const fs = require('fs');


if (process.argv.length < 3) {
    console.log('You have to provide a name to your app.');
    console.log('For example :');
    console.log('    npx create-my-boilerplate my-app');
    process.exit(1);
}

const projectName = process.argv[2];
const currentPath = process.cwd();
const projectPath = path.join(currentPath, projectName);
const git_repo = 'https://github.com/aadarshbabu/create-express-app'

try {
    fs.mkdirSync(projectPath);
} catch (err) {
    if (err.code === 'EEXIST') {
        console.log(`The file ${projectName} already exist in the current directory, please give it another name.`);
    } else {
        console.log(error);
    }
    process.exit(1);
}


async function main() {

    try {
        console.log('Downloading files...');
        execSync(`git clone --depth 1 ${git_repo} ${projectPath}`);

        process.chdir(projectPath);

        console.log('Installing dependencies...');
        execSync('npm install');

        // console.log('Removing useless files');
        // fs.rmdirSync(path.join(projectPath, 'bin'), { recursive: true });

        console.log('The installation is done, this is ready to use !');

        console.log("Start a Express Server Type  '''npm start''' ");
        console.log("Build a Express Application  '''npm Build'''  ");
        console.log("if you want to devlope a Express Application you can run a command '''npm dev'''  ");

    } catch (error) {
        console.log(error);
    }

}
main();